%define additional_effect_plugin_a sox-effect-0.0.1
%define additional_misc_plugin_a xmms-shell-0.99.3
%define prever pre1
%define use_prever 0
%define build_gnome 0

Summary: The Sound player with the WinAmp GUI
Name: xmms
Version: 1.2.7
Release: alt7
License: GPL
Group: Sound
Icon: xmms-logo.xpm
Url: http://www.xmms.org/

%if %use_prever
Source0: http://www.xmms.org/%name-%version-%prever.tar.bz2
%else
Source0: http://www.xmms.org/%name-%version.tar.bz2
%endif
Source2: gnomexmms.desktop.bz2
Source4: %name-icons.tar.bz2
Source5: %name
Source8: %name-ru.po.bz2
Source10: %name.16.xpm.bz2
Source11: %name.32.xpm.bz2
Source12: %name.48.xpm.bz2
Source50: http://staff.xmms.org/zinx/xmms/%additional_effect_plugin_a.tar.bz2
Source51: http://xmms-shell.sourceforge.net/%additional_misc_plugin_a.tar.bz2

Patch1: xmms-1.2-audio-patch
Patch2: xmms-shell-0.99.3-fix-missing-ncurses.patch
Patch3: xmms-1.2.7-xmms-shell-fix-bootstrap.patch
Patch4: xmms-fix-smallfiles.patch
Patch5: xmms-1.2.6-fix-title-mp3streaming.patch
Patch6: xmms-fix-textbox.patch
Patch7: xmms-1.2.5-3dse-11.patch
Patch8: xmms-3dse-niqueluisarace.patch
Patch9: xmms-1.2.7-intl.patch.bz2
Patch10: xmms-1.2.6-rus.patch.bz2
Patch11: xmms-1.2.7-opt.patch
Patch12: xmms-1.2.7-c++fixes.patch
Patch13: xmms-1.2.6-E_option.patch
Patch14: xmms-1.2.6-sort1.patch
Patch15: xmms-1.2.6-sort2.patch
Patch16: xmms-shell-0.99.3-readline-fix.patch
Patch17: xmms-1.2.7-missing-includes.patch

# Local patches
Patch41: xmms-1.2.6-filebrowser_get_files.patch
Patch42: xmms-1.2.7-automake.patch
Patch43: xmms-1.2.7-local-libxmms_n.patch
Patch44: xmms-1.2.7-setuid.patch

BuildPreReq: gtk+-devel libvorbis-devel libogg-devel db1-devel libmikmod-devel
%if %build_gnome
BuildPreReq: gnome-core-devel
%endif
Obsoletes: x11amp
Requires: libxmms = %version-%release


%description
XMMS is a sound player written from scratch. Since it uses the WinAmp GUI, it
can use WinAmp skins, and play mp3s, mods, s3ms, and other formats. It now has
support for input, output, and general plugins, and has also been GPLd.

This package also provides an effect plugin based on Sox and a shell for xmms
in order to command the running xmms from any script/commandline.

%description -l ru_RU.KOI8-R
X MultiMedia System -   .    
  WinAmp,     WinAmp.  
   : mp3s, mods, s3ms,   . 
    input, output, general,  visualization .

%package -n libxmms
Summary: Library associated with xmms, needed for xmms and its plugins.
Group: System/Libraries
Icon: xmms-logo.xpm
Requires: libxmms = %version-%release

%description -n libxmms
This library is mandatory for xmms and for all its plugins to run.

%description  -n libxmms -l ru_RU.KOI8-R
    xmms    .

%package -n libxmms-devel
Summary: Development package with headers
Group: Development/C
Icon: xmms-devel-logo.xpm
Requires: libxmms = %version-%release
Provides: xmms-devel = %version-%release
Obsoletes: xmms-devel

%description -n libxmms-devel
Header files required for compiling xmms plugins.

%description -n libxmms-devel -l ru_RU.KOI8-R
       xmms.

%package -n libxmms-devel-static
Summary: Development package with static libs
Group: Development/C
Requires: libxmms-devel = %version-%release
Obsoletes: xmms-devel-static
Provides: xmms-devel-static = %version-%release

%description -n libxmms-devel-static
Static libraries required for compiling xmms plugins.

%description -n libxmms-devel-static -l ru_RU.KOI8-R
     
 xmms.

%package esd
Summary: ESound output backend
Group: Sound
Icon: xmms-esd-logo.xpm
BuildPreReq: esound-devel
Requires: %name = %version-%release
Obsoletes: x11amp-esd
Requires: esound >= 0.2.14

%description esd
Output plugin for xmms for use with the esound package

%description esd -l ru_RU.KOI8-R
Output      esound

%package diskwriter
Summary: DiskWriter output backend
Group: Sound
Requires: %name = %version-%release

%description diskwriter
Output plugin for xmms in order to output *.wav files instead of playing
sound on the soundcard.

%if %build_gnome
%package gnome
Summary: Gnome applet for XMMS
Group: Graphical desktop/GNOME
Icon: xmms-gnome-logo.xpm
Requires: %name = %version-%release
Obsoletes: x11amp-gnome

%description gnome
GNOME applet for controlling xmms from the GNOME panel

%description gnome -l ru_RU.KOI8-R
XMMS -    xmms   GNOME
%endif

%package mikmod
Summary: Sound player with the WinAmp GUI, Mikmod output backend
Group: Sound
Icon: xmms-mikmod-logo.xpm
BuildPreReq: libmikmod-devel
Obsoletes: x11amp-mikmod
Requires: %name = %version-%release
Requires: libmikmod >= 3.1.6

%description mikmod
Input plugin for XMMS to play MODs (.MOD,.XM,.S3M, etc)

%package mesa
Summary: Visualization plugins that use the Mesa3d library
Group: Sound
Icon: xmms-mesa-logo.xpm
Requires: %name = %version-%release
BuildPreReq: Mesa-devel

%description mesa
3D Visualization plugins for XMMS that use the Mesa3d library.

%description mesa -l ru_RU.KOI8-R
Visualization ,   Mesa3d.

%package vorbis
Summary: XMMS - Input plugin that use the Vorbis library
Summary(ru):	XMMS - Input ,   Vorbis.
Group: Sound
#Icon:		xmms-mesa-logo.xpm
Requires: %name = %version-%release, libvorbis >= 1.0rc2, libogg >= 1.0rc2
BuildPreReq: libvorbis

%description vorbis
Input plugins that use the Vorbis library.

%description vorbis -l ru_RU.KOI8-R
Input ,   Vorbis.

%prep
%if %use_prever
%setup -n xmms-%version-%prever -q -a 50 -a 51
%else
%setup -n xmms-%version -q -a 50 -a 51
%endif
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1

%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1

bzcat %SOURCE8 > po/ru.po

%define _optlevel 3
%add_optflags %optflags_notraceback -funroll-all-loops

%build
aclocal -I aclocal
autoconf
automake -a
pushd libxmms
autoconf
popd
export CFLAGS="$RPM_OPT_FLAGS `glib-config --cflags` -I/usr/X11R6/include/GL $(orbit-config --cflags client server)"
%configure --enable-3dnow --enable-recode
%make

# (gc) I want to grab the xmms-config built in .., for bootstrapping nicely
export PATH=.:$PATH
cd %additional_effect_plugin_a
aclocal
autoconf
automake -a -f
CFLAGS="$RPM_OPT_FLAGS $(glib-config --cflags) $(gtk-config --cflags)" \
%configure
%make_build
cd ..

cd %additional_misc_plugin_a
aclocal
autoconf
# depcomp provided is too old for automake-1.6
automake -a -f
CFLAGS="$RPM_OPT_FLAGS $(glib-config --cflags) $(gtk-config --cflags)" \
%configure
# (gc) this sucking rpath thing...
perl -ni -e 'print if !m|--rpath|' *
make

perl -pi -e 's/-rpath//' Visualization/opengl_spectrum/Makefile*

%make_build
cd ..

%install
mkdir -p $RPM_BUILD_ROOT/%_libdir/xmms/Effect
mkdir -p $RPM_BUILD_ROOT/%_libdir/xmms/General
mkdir -p $RPM_BUILD_ROOT/%_libdir/xmms/Input
mkdir -p $RPM_BUILD_ROOT/%_libdir/xmms/Output
mkdir -p $RPM_BUILD_ROOT/%_libdir/xmms/Visualization
mkdir -p $RPM_BUILD_ROOT/%_datadir/xmms/Skins
mkdir -p $RPM_BUILD_ROOT/%_docdir

make DESTDIR=$RPM_BUILD_ROOT install

cd %additional_effect_plugin_a
%makeinstall libdir=$RPM_BUILD_ROOT/%_libdir/xmms/Effect
cd ..

cd %additional_misc_plugin_a
%makeinstall PREFIX=$RPM_BUILD_ROOT/%prefix
cd ..

install -m644 $RPM_SOURCE_DIR/xmms-logo.xpm $RPM_BUILD_ROOT/%_datadir/xmms/xmms.xpm

# compatibility symlink
[ -r $RPM_BUILD_ROOT%_libdir/libxmms.so.1 ] && \
	ln -s libxmms.so.1 $RPM_BUILD_ROOT%_libdir/libxmms.so.0

mkdir -p $RPM_BUILD_ROOT%_datadir/mime-info
cat > $RPM_BUILD_ROOT%_datadir/mime-info/xmms.keys << EOF
audio/x-mp3:
	open=xmms %f
	view=xmms %f
EOF
chmod 644 $RPM_BUILD_ROOT%_datadir/mime-info/xmms.keys

mkdir -p $RPM_BUILD_ROOT%_datadir/pixmaps
if [ ! -r $RPM_BUILD_ROOT%_datadir/pixmaps/xmms_logo.xpm ]; then
	cp $RPM_SOURCE_DIR/xmms-logo.xpm \
		$RPM_BUILD_ROOT%_datadir/pixmaps/xmms.xpm
fi

# menu
mkdir -p $RPM_BUILD_ROOT/%_menudir
install -m 644 %SOURCE5 $RPM_BUILD_ROOT/%_menudir

# icons
mkdir -p $RPM_BUILD_ROOT/%_miconsdir
mkdir -p $RPM_BUILD_ROOT/%_liconsdir
bzcat %SOURCE10 > $RPM_BUILD_ROOT/%_miconsdir/%name.xpm
bzcat %SOURCE11 > $RPM_BUILD_ROOT/%_iconsdir/%name.xpm
bzcat %SOURCE12 > $RPM_BUILD_ROOT/%_liconsdir/%name.xpm

%find_lang %name

%post
/sbin/ldconfig
%update_menus

%postun
/sbin/ldconfig
%clean_menus

%files -f %name.lang
%doc AUTHORS ChangeLog NEWS NEWS-RUS README README-RUS TODO
%dir %_datadir/xmms
%dir %_libdir/xmms
%dir %_libdir/xmms/Input
%dir %_libdir/xmms/Output
%dir %_libdir/xmms/General
%dir %_libdir/xmms/Effect
%dir %_libdir/xmms/Visualization
%_bindir/xmms
%_bindir/wmxmms
%_bindir/xmms-shell
%_libdir/xmms/Input/libcdaudio*
%_libdir/xmms/Input/libmpg123*
%_libdir/xmms/Input/libwav*
%_libdir/xmms/Input/libidcin*
%_libdir/xmms/Input/libtonegen*
%_libdir/xmms/Output/libOSS*
%_libdir/xmms/General/*
%_libdir/xmms/Effect/*
%_libdir/xmms/Visualization/libbscope*
%_libdir/xmms/Visualization/libsanalyzer*
%_datadir/xmms/wmxmms.xpm
%_datadir/xmms/xmms.xpm
%_iconsdir/%name.xpm
%_miconsdir/%name.xpm
%_liconsdir/%name.xpm
%_menudir/*
%_mandir/man1/xmms.1.*
%_mandir/man1/wmxmms.1.*

%files -n libxmms
%_libdir/libxmms.so.*

%files -n libxmms-devel
%_libdir/lib*.so
%_libdir/lib*.la
%_includedir/*
%_datadir/aclocal/xmms.m4
%_bindir/xmms-config

%files -n libxmms-devel-static
%_libdir/lib*.a

%files esd
%_libdir/xmms/Output/libesdout*

%files diskwriter
%_libdir/xmms/Output/libdisk_writer*

%if %build_gnome
%files gnome
%config(noreplace) /etc/CORBA/servers/*
%_bindir/gnomexmms
%_datadir/applets/Multimedia/gnomexmms.desktop
%_datadir/mime-info/xmms.keys
%_datadir/pixmaps/*
%_mandir/man1/gnomexmms.1.*
%endif

%files mikmod
%_libdir/xmms/Input/libmikmod*

%files mesa
%_libdir/xmms/Visualization/libogl_spectrum*

%files vorbis
%_libdir/xmms/Input/libvorbis*

%changelog
* Thu Oct 31 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt7
- Added patches from Alexey Morozov <morozov@novosoft.ru>
  - Re-applied GTK+ File Browsing fix patch
  - Re-applied autoconf-2.5 / automake-1.6 compatibility patches
  - automake-1.6 fixes for build process
- Fixed xmms-locallib patch

* Thu Oct 24 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt6
- Rebuilt in new environment
- Updated xmms-shell to 0.99.3
- Now we don't build xmms-gnome package

* Wed Aug 27 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt5
- Fixed recoding - now xmms don't recode characters that absent in
  result codeset. Thnx to Vitaly Lipatov
- Added gcc3 patches from MDK

* Wed Jul 31 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt4
- Rebuilt with new OGG
- Changed make_build to make - bugs with man pages

* Mon Apr 29 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt3
- Package xmms splitted to xmms & libxmms

* Thu Apr 11 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt2
- Updated xmms-shell & 3dse plugins to latest versions

* Tue Mar 05 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.7-alt1
- 1.2.7
- Fixed Russian description for xmms package

* Thu Jan 24 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.2.6-alt1
- 1.2.6-release
- Updated rus & intl patches - fixed some bugs (Apply in preferences
  & Vorbis recoding)
- Updated russian translation file

* Mon Dec 10 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.2.6-alt0.2.pre1
- Fixed requires for xmms-vorbis (>= 1.0rc2). Thanx to Mikhail Yakshin.
- Fixed Requires (%version-%release).

* Fri Dec 07 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.2.6-alt0.1.pre1
- 1.2.6-pre1
- Fixed filelist
- Some spec cleanup

* Mon Nov 19 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.2.5-alt3
- Fixed ORBit cflags

* Thu Jun 28 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.2.5-alt2
- Fixed plugin.h

* Wed Jun 20 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.2.5-alt1
- Update to new version - 1.2.5
- Fix some patches
- Added manpages to xmms
- Remove all entries in changelog before 2001
- Some spec cleanup

* Wed Apr 25 2001 Kostya Timoshenko <kt@altlinux.ru> 1.2.4-ipl7mdk
- Moved static libraries to devel-static subpackage.

* Fri Mar 16 2001 Konstantin Volckov <goldhead@linux.ru.net>  1.2.4-ipl6mdk
- Final rebuild for RE

* Mon Mar 12 2001 Kostya Timoshenko <kt@petr.kz> 1.2.4-ipl5mdk
- added a patch to fix wchar_t to GdkWChar conversion problem in
  playlist_list.c, thanks to Chun-Chung Chen <cjj@u.washington.edu>
- Geoffrey Lee <snailtalk@mandrakesoft.com>
  - Ugly hack to make it build with the latest glib/gtk.

* Fri Feb  9  2001 Kostya Timoshenko <kt@petr.kz> 1.2.4-ipl4mdk
- change tag Group

* Tue Jan 16 2001 Kostya Timoshenko <kt@petr.kz>
- fix lib policy

* Tue Jan  2 2001 Kostya Timoshenko <kt@petr.kz>
- Use patches by Konstantin Volckov <goldhead@linux.ru.net>
- Build for RE
